package jumpstart.min.web.commons.validator;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.apache.tapestry.form.validator.MaxDate;

public class MaxDateISO extends MaxDate {
	private static final String isoFormatStr = "yyyy-MM-dd";
	private static final DateFormat isoDateFormat = new SimpleDateFormat(isoFormatStr);

	public void setMaxDateISO(String maxDateISO) {
		try {
			Date date = isoDateFormat.parse(maxDateISO);
			super.setMaxDate(date);
		}
		catch (ParseException e) {
			throw new IllegalArgumentException("Value received for maxDateISO is \"" + maxDateISO
					+ "\" which does not match format \"" + isoFormatStr + "\".", e);
		}
	}

}
