package jumpstart.min.web.commons.validator;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.apache.tapestry.form.validator.MinDate;

public class MinDateISO extends MinDate {
	private static final String isoFormatStr = "yyyy-MM-dd";
	private static final DateFormat isoDateFormat = new SimpleDateFormat(isoFormatStr);

	public void setMinDateISO(String minDateISO) {
		try {
			Date date = isoDateFormat.parse(minDateISO);
			super.setMinDate(date);
		}
		catch (ParseException e) {
			throw new IllegalArgumentException("Value received for minDateISO is \"" + minDateISO
					+ "\" which does not match format \"" + isoFormatStr + "\".", e);
		}
	}

}
