package jumpstart.min.web.pages.security;

import jumpstart.min.business.commons.exception.ServiceException;
import jumpstart.min.business.domain.security.User;
import jumpstart.min.business.domain.security.iface.ISecurityFinderSvcLocal;
import jumpstart.min.web.pages.base.ProtectedBasePage;

import org.apache.tapestry.annotations.Persist;

public abstract class UserViewPage extends ProtectedBasePage {
	static public final String PAGE_NAME = "pages/security/UserViewPage";
	
	@Persist("client")
	public abstract Long getUserId();
	public abstract void setUserId(Long value);

	@Persist("session")
	// Probably best not to use client persistence, although it does encode the
	// data, because User inludes password
	public abstract User getUser();
	public abstract void setUser(User value);
	
	public void activate(Long id) throws ServiceException {
		setUserId(id);

		// Get the User

		ISecurityFinderSvcLocal securityFinder = getBizServicesLocator().getSecurityFinderSvcLocal();
		User user = securityFinder.findUser(id);
		setUser(user);

		getRequestCycle().activate(this);
	}

	public void doCancel() {
		UserSearchPage nextPage = (UserSearchPage) getRequestCycle().getPage(UserSearchPage.PAGE_NAME);
		nextPage.activateAgain();
	}
	
}
