package jumpstart.min.web.state;

import java.io.Serializable;

import jumpstart.min.business.domain.security.User;

@SuppressWarnings("serial")
public class Visit implements Serializable {
	
	// The logged in user
	private boolean _loggedIn = false;
	private Long _myUserId = null;
	private String _myLoginId = null;
	
	//
	// The User
	//

	public void noteLogIn(User user) {
		_loggedIn = true;
		_myUserId = user.getId();
		_myLoginId = user.getLoginId();
	}

	public void noteLogOut() {
		_loggedIn = false;
		_myUserId = null;
		_myLoginId = null;
	}

	public boolean isLoggedIn() {
		return _loggedIn;
	}

	public Long getMyUserId() {
		return _myUserId;
	}

	public String getMyLoginId() {
		return _myLoginId;
	}

}
